> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://reference.flatfile.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://reference.flatfile.com/_mcp/server.

# Update a routine

PATCH https://api.x.flatfile.com/v1/routines/{routineId}
Content-Type: application/json

Updates a routine

Reference: https://reference.flatfile.com/api-reference/routines/update

## Authentication

- `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer <token>`, where token is your auth token.

## Request

### Path parameters

- `routineId` (string, required) — Routine ID

### Body (application/json)

This endpoint expects an UpdateRoutineRequest.

- `name` (string, required) — The name of the Routine.
- `config` (any, required) — Configuration for the Routine. Related to the type of Routine.
- `ordinal` (integer, required) — The order of the Routine in the Runbook.
- `type` (enum, required) — The type of Routine.
  - Allowed values: `JOB`

## Response

### 200

- `data` (Routine, required) — Routine is a set of instructions or procedures that are followed to complete a task.

## Errors

### 400 Bad Request Error

- `errors` (list of Error, required)

### 404 Not Found Error

- `errors` (list of Error, required)

## Types

### Routine

Routine is a set of instructions or procedures that are followed to complete a task.

- `id` (string, required) — The ID of the Routine.
- `runbookId` (string, required) — Runbook ID
- `name` (string, required) — The name of the Routine.
- `config` (any, required) — Configuration for the Routine. Related to the type of Routine.
- `ordinal` (integer, required) — The order of the Routine in the Runbook.
- `type` (enum, required) — The type of Routine.
  - Allowed values: `JOB`
- `createdBy` (string, required) — The entity which created the Runbook.
- `createdAt` (datetime, required) — Date the sheet was created
- `updatedAt` (datetime, required) — Date the sheet was last updated

### Error

- `message` (string, required)
- `key` (string, optional)

## Examples

**Request**

```json
{
  "name": "Split Address to Street, City, State, Zip",
  "config": {
    "sourceSheetId": "us_sh_YOUR_ID",
    "destinationSheetId": "us_sh_YOUR_ID",
    "programId": "us_mp_YOUR_ID"
  },
  "ordinal": 1,
  "type": "JOB"
}
```

**Response**

```json
{
  "data": {
    "id": "us_rtn_YOUR_ID",
    "runbookId": "us_rb_YOUR_ID",
    "name": "Split Address to Street, City, State, Zip",
    "config": {
      "sourceSheetId": "us_sh_YOUR_ID",
      "destinationSheetId": "us_sh_YOUR_ID",
      "programId": "us_mp_YOUR_ID"
    },
    "ordinal": 1,
    "type": "JOB",
    "createdBy": "us_usr_YOUR_ID",
    "createdAt": "2024-12-05T00:00:00Z",
    "updatedAt": "2024-12-05T00:00:00Z"
  }
}
```

**SDK Code**

```typescript Example0
import { FlatfileClient } from "@flatfile/api";

const client = new FlatfileClient({ token: "YOUR_TOKEN" });
await client.routines.update("us_rtn_YOUR_ID", {
    name: "Split Address to Street, City, State, Zip",
    config: {
        "sourceSheetId": "us_sh_YOUR_ID",
        "destinationSheetId": "us_sh_YOUR_ID",
        "programId": "us_mp_YOUR_ID"
    },
    ordinal: 1,
    type: "JOB"
});

```

```python Example0
import requests

url = "https://api.x.flatfile.com/v1/routines/us_rtn_YOUR_ID"

payload = {
    "name": "Split Address to Street, City, State, Zip",
    "config": {
        "sourceSheetId": "us_sh_YOUR_ID",
        "destinationSheetId": "us_sh_YOUR_ID",
        "programId": "us_mp_YOUR_ID"
    },
    "ordinal": 1,
    "type": "JOB"
}
headers = {
    "X-Disable-Hooks": "true",
    "Authorization": "Bearer <token>",
    "Content-Type": "application/json"
}

response = requests.patch(url, json=payload, headers=headers)

print(response.json())
```

```go Example0
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.x.flatfile.com/v1/routines/us_rtn_YOUR_ID"

	payload := strings.NewReader("{\n  \"name\": \"Split Address to Street, City, State, Zip\",\n  \"config\": {\n    \"sourceSheetId\": \"us_sh_YOUR_ID\",\n    \"destinationSheetId\": \"us_sh_YOUR_ID\",\n    \"programId\": \"us_mp_YOUR_ID\"\n  },\n  \"ordinal\": 1,\n  \"type\": \"JOB\"\n}")

	req, _ := http.NewRequest("PATCH", url, payload)

	req.Header.Add("X-Disable-Hooks", "true")
	req.Header.Add("Authorization", "Bearer <token>")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby Example0
require 'uri'
require 'net/http'

url = URI("https://api.x.flatfile.com/v1/routines/us_rtn_YOUR_ID")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Patch.new(url)
request["X-Disable-Hooks"] = 'true'
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"name\": \"Split Address to Street, City, State, Zip\",\n  \"config\": {\n    \"sourceSheetId\": \"us_sh_YOUR_ID\",\n    \"destinationSheetId\": \"us_sh_YOUR_ID\",\n    \"programId\": \"us_mp_YOUR_ID\"\n  },\n  \"ordinal\": 1,\n  \"type\": \"JOB\"\n}"

response = http.request(request)
puts response.read_body
```

```java Example0
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.patch("https://api.x.flatfile.com/v1/routines/us_rtn_YOUR_ID")
  .header("X-Disable-Hooks", "true")
  .header("Authorization", "Bearer <token>")
  .header("Content-Type", "application/json")
  .body("{\n  \"name\": \"Split Address to Street, City, State, Zip\",\n  \"config\": {\n    \"sourceSheetId\": \"us_sh_YOUR_ID\",\n    \"destinationSheetId\": \"us_sh_YOUR_ID\",\n    \"programId\": \"us_mp_YOUR_ID\"\n  },\n  \"ordinal\": 1,\n  \"type\": \"JOB\"\n}")
  .asString();
```

```php Example0
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('PATCH', 'https://api.x.flatfile.com/v1/routines/us_rtn_YOUR_ID', [
  'body' => '{
  "name": "Split Address to Street, City, State, Zip",
  "config": {
    "sourceSheetId": "us_sh_YOUR_ID",
    "destinationSheetId": "us_sh_YOUR_ID",
    "programId": "us_mp_YOUR_ID"
  },
  "ordinal": 1,
  "type": "JOB"
}',
  'headers' => [
    'Authorization' => 'Bearer <token>',
    'Content-Type' => 'application/json',
    'X-Disable-Hooks' => 'true',
  ],
]);

echo $response->getBody();
```

```csharp Example0
using RestSharp;

var client = new RestClient("https://api.x.flatfile.com/v1/routines/us_rtn_YOUR_ID");
var request = new RestRequest(Method.PATCH);
request.AddHeader("X-Disable-Hooks", "true");
request.AddHeader("Authorization", "Bearer <token>");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"name\": \"Split Address to Street, City, State, Zip\",\n  \"config\": {\n    \"sourceSheetId\": \"us_sh_YOUR_ID\",\n    \"destinationSheetId\": \"us_sh_YOUR_ID\",\n    \"programId\": \"us_mp_YOUR_ID\"\n  },\n  \"ordinal\": 1,\n  \"type\": \"JOB\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift Example0
import Foundation

let headers = [
  "X-Disable-Hooks": "true",
  "Authorization": "Bearer <token>",
  "Content-Type": "application/json"
]
let parameters = [
  "name": "Split Address to Street, City, State, Zip",
  "config": [
    "sourceSheetId": "us_sh_YOUR_ID",
    "destinationSheetId": "us_sh_YOUR_ID",
    "programId": "us_mp_YOUR_ID"
  ],
  "ordinal": 1,
  "type": "JOB"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.x.flatfile.com/v1/routines/us_rtn_YOUR_ID")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "PATCH"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```